package com.medipreco.loopboxplugin;

import br.com.loopkey.indigo.lklib.LKLib;
import br.com.loopkey.indigo.lklib.LKMainThreadImpl;
import br.com.loopkey.indigo.lklib.core.LKReachableDevice;
import br.com.loopkey.indigo.lklib.core.LKReachableDeviceImpl;
import br.com.loopkey.indigo.lklib.core.LKReachableDeviceListener;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** LoopboxpluginPlugin */
public class LoopboxpluginPlugin implements FlutterPlugin, MethodCallHandler {

  private LKReachableDevice reachableDevice;
  private LKReachableDeviceListener reachableDeviceListener;

  public LoopboxpluginPlugin() {
    LKLib.install(LKLib.provideContext(), new LKMainThreadImpl());
    reachableDevice = LKReachableDeviceImpl.newInstance();
  }

  @Override
  public void onAttachedToEngine(FlutterPluginBinding flutterPluginBinding) {
    final MethodChannel channel = new MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(),
        "loopboxplugin");
    channel.setMethodCallHandler(new LoopboxpluginPlugin());
  }

  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "loopboxplugin");
    channel.setMethodCallHandler(new LoopboxpluginPlugin());
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equals("startListeningNearbyDevices")) {
      this.startListeningNearbyDevices();
    } else {
      result.notImplemented();
    }
  }

  private void startListeningNearbyDevices() {
    this.reachableDeviceListener = new ReachableDeviceListener();
    reachableDevice.subscribe(this.reachableDeviceListener);
  }

  @Override
  public void onDetachedFromEngine(FlutterPluginBinding binding) {
  }
}
